// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_contracts_with_grant_type_filter.sql

package queries

import (
	"context"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

const listContractsWithGrantTypeFilter = `-- name: ListContractsWithGrantTypeFilter :many

SELECT
    c.iv AS content_iv,
    c.hash as content_hash,
    c.hash_algorithm as content_hash_algorithm,
    c.group_id as content_group_id,
    c.valid_not_before as content_valid_not_before,
    c.valid_not_after as content_valid_not_after,
    c.created_at as content_created_at
FROM
    contracts.with_grant_type as c
WHERE
    (
        $2 = ''
        or
        (
            $3::text = 'asc'
            and
            (
                c.created_at::timestamp > $4::timestamp with time zone
                or
                (
                    c.created_at::timestamp = $4::timestamp with time zone
                    and
                    c.hash > $2::text
                )
            )
        )
        or
        (
            $3::text = 'desc'
            and
                (
                c.created_at::timestamp < $4::timestamp with time zone
                or
                (
                    c.created_at::timestamp = $4::timestamp with time zone
                    and
                    c.hash < $2::text
                )
            )
        )
    ) and (
        (
            c.has_service_connection_grant =
            CASE WHEN $5 = true THEN true ELSE NULL END
        ) OR
        (
            c.has_delegated_service_connection_grant =
            CASE
                WHEN $6 = true
                THEN true
            ELSE NULL END
        ) OR
        (
            c.has_service_publication_grant =
            CASE
                WHEN $7 = true
                    THEN true
                ELSE NULL
                END
        ) OR
        (
            c.has_delegated_service_publication_grant =
            CASE
                WHEN $8 = true
                    THEN true
                ELSE NULL
                END
        )
    )
ORDER BY
CASE
    WHEN $3::text = 'asc' THEN c.created_at END ASC,
CASE
    WHEN $3::text = 'asc' THEN c.hash COLLATE "C" END ASC,
CASE
    WHEN $3::text = 'desc' THEN c.created_at END DESC,
CASE
    WHEN $3::text = 'desc' THEN c.hash COLLATE "C" END DESC
LIMIT $1
`

type ListContractsWithGrantTypeFilterParams struct {
	Limit                                 int32
	PaginationStartHash                   interface{}
	OrderDirection                        string
	PaginationStartDate                   pgtype.Timestamptz
	WithServiceConnectionGrants           interface{}
	WithDelegatedServiceConnectionGrants  interface{}
	WithServicePublicationGrants          interface{}
	WithDelegatedServicePublicationGrants interface{}
}

type ListContractsWithGrantTypeFilterRow struct {
	ContentIv             uuid.UUID
	ContentHash           string
	ContentHashAlgorithm  ContractsContentHashAlgorithm
	ContentGroupID        string
	ContentValidNotBefore pgtype.Timestamptz
	ContentValidNotAfter  pgtype.Timestamptz
	ContentCreatedAt      pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListContractsWithGrantTypeFilter(ctx context.Context, arg *ListContractsWithGrantTypeFilterParams) ([]*ListContractsWithGrantTypeFilterRow, error) {
	rows, err := q.db.Query(ctx, listContractsWithGrantTypeFilter,
		arg.Limit,
		arg.PaginationStartHash,
		arg.OrderDirection,
		arg.PaginationStartDate,
		arg.WithServiceConnectionGrants,
		arg.WithDelegatedServiceConnectionGrants,
		arg.WithServicePublicationGrants,
		arg.WithDelegatedServicePublicationGrants,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListContractsWithGrantTypeFilterRow{}
	for rows.Next() {
		var i ListContractsWithGrantTypeFilterRow
		if err := rows.Scan(
			&i.ContentIv,
			&i.ContentHash,
			&i.ContentHashAlgorithm,
			&i.ContentGroupID,
			&i.ContentValidNotBefore,
			&i.ContentValidNotAfter,
			&i.ContentCreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
